if (typeof _497BFC326A484FAC8AB6B8CD0D886127 === "undefined") {
	_497BFC326A484FAC8AB6B8CD0D886127 = {};
}

(function(){
var global = this;
if (global.net === undefined) {
	global.net = {};
}



global.common.HasObserverBase = function() {
	this.observers = [];
};
global.common.HasObserverBase.prototype = {
	
	addObserver: function(observer, name) {
		this.observers.push({
			observer: observer,
			name: name
		});
	},
	
	notifyObservers: function(arg) {
		for (var i=0; i < this.observers.length; i++) {
			var observer = this.observers[i];
			try {
				this.logTrace("> notifyObservers: " + observer.name);
				observer.observer(arg);
			} catch (e) {
				this.logError("notifyObservers error on " + observer.name + ": " + e);
			}
		}
	}
};



/*****************************/
/* START CentrifyBEHttp401Base */
global.login.CentrifyBEHttp401Base = function() {
	global.common.CentrifyBEBase.call(this);
};
global.login.CentrifyBEHttp401Base.prototype = {

	loggerName: "H401",

	/**
	 */
	end: function(carryOver) {
		try {
			this.clearLoginData(carryOver);
		} catch (err) {
			this.logError("fail to clear loginData - " + err);
		}
	},
	
	/**
	 */
	abort: function(carryOver, message) {
		if (this.debugMode) {
			this.logError(message);
		} else {
			this.logError(message);
		}		
		this.end(carryOver);
	},
	
	/**
	 * @param {centrify.LoginData} loginData
	 * @param {string} message
	 */
	logSeq: function(loginData, message) {
		var command = loginData.order[loginData.currentOrder];
		var m = "T-" + loginData.currentOrder + "/" + loginData.order.length + " " + command;
		if (message) {
			m += ": " + message;
		}
		this.log(m);
	},
	
	recevied401Header: function(carryOver, loginData) {
		if (!loginData) {
			this.log("ignore. URL = " + carryOver.url);
			return;
		}
		this.log("start. URL = " + carryOver.url);
		
		// check the loginData http protocol and the tab's url protocol
		if (!this.checkBackgroundProtocol(carryOver, loginData)) {
			var message = "This login page is not secure.<br>The application you are trying to access is configured to require a secure, encrypted, connection (HTTPS).<br>However, this login page is not encrypted (HTTP).";
			this.promptWarningDiag(carryOver, message);
			return;
		}
		
		var isLoginDataUpdated = false;
		if (!loginData.order) {
			// if the "order" is missing in the loginData, using ups which is the existing behavior.
			global.login.Common.initDefaultLoginOrder(loginData);
			isLoginDataUpdated = true;
		}
		
		if (loginData.currentOrder !== undefined) {
			if (loginData.currentOrder >= loginData.order.length) {
				this.abort(carryOver, "OrderOfBound, currentOrder = " + loginData.currentOrder 
						+ ", total = " + loginData.order.length);
				return false;
			}
			var command = loginData.order[loginData.currentOrder];
			
			var previousCommand = (loginData.currentOrder >= 1) 
					? loginData.order[loginData.currentOrder - 1] 
					: null;
			
			if (command[0] === global.login.LoginOrderEnum.newPage) {
				++loginData.currentOrder;
				isLoginDataUpdated = true;
			} else if (previousCommand[0] == global.login.LoginOrderEnum.gotoUrl 
					|| previousCommand[0] == global.login.LoginOrderEnum.header401) {
				// do nothing, even we don't see the newPage command but we know this will be a new page after gotoUrl.
			} else {
				this.abort(carryOver, "Unexpected login order, expect " 
						+ global.login.LoginOrderEnum.newPage + " but got " + command[0]);
				return false;
			}
		} else {
			loginData.currentOrder = 0;
			isLoginDataUpdated = true;
		}
		
		if (isLoginDataUpdated) {
			this.updateLoginData(carryOver, loginData);
		}
		
		this.executeCommands(carryOver, loginData);
	},
	
	executeCommands: function(carryOver, loginData) {
		if (loginData.order.length <= loginData.currentOrder) {
			this.log("no more command to run");
			//nothing more to do
			this.end(carryOver);
			return;
		}
		
		var command = loginData.order[loginData.currentOrder];
		this.logSeq(loginData);
		switch (command[0]) {
			case global.login.LoginOrderEnum.click:
			case global.login.LoginOrderEnum.ups:
			case global.login.LoginOrderEnum.sleep:
			case global.login.LoginOrderEnum.fill:
			case global.login.LoginOrderEnum.fillEnter:
			case global.login.LoginOrderEnum.submit:
			case global.login.LoginOrderEnum.gotoUrl:
				this.abort(carryOver, "UnsupportedCommand  " + command[0]);
				break;
			case global.login.LoginOrderEnum.newPage:
				this.executeCommandNewPage(carryOver, loginData);
				break;
			case global.login.LoginOrderEnum.header401:
				this.executeCommandHeader401(carryOver, loginData);
				break;
			default:
				this.abort(carryOver, "Unknown command in the order: " + command[0]);
				break;
		}
	},
	
	getFieldValueByName: function(loginData, fieldName) {
		for (var i = 0; i < loginData.fields.length; i++) {
			var fieldData = loginData.fields[i];
			if (fieldData.name == fieldName) {
				return fieldData.value;
			}
		}
		return null;
	},
	
	executeCommandNewPage: function(carryOver, loginData) {
		var command = loginData.order[loginData.currentOrder];
		var skipCondition = command[1];
		
		var shouldSkip = false;
		if (skipCondition) {
			//can't check the url since it isn't available.
			//if (skipCondition.url && carryOver.url && carryOver.url.match(skipCondition.url)) {
			//	shouldSkip = true;
			//}
			if (skipCondition.httpStatus && "401".match(skipCondition.httpStatus)) {
				shouldSkip = true;
			}
		}
		
		if (shouldSkip) {
			this.log("The skip condition is met in waitForNewPage. No wait");
			++loginData.currentOrder;
			this.updateLoginData(carryOver, loginData);
			this.executeCommands(carryOver, loginData);
		} else {
			this.log("The waiting for next page load. Zzz");
		}
	}, 
	
	executeCommandHeader401: function(carryOver, loginData) {
		switch (loginData.scheme) {
			case global.login.SchemeEnum.ftp:
			case global.login.SchemeEnum.basic:
			case global.login.SchemeEnum.any:
				break;
			default:
				this.abort(carryOver, "loginData.scheme is not supported. It is " + loginData.scheme);
				return;
		}
		
		this.log("start setting basic auth");
		var username = this.getFieldValueByName(loginData, "username");
		var password = this.getFieldValueByName(loginData, "password");
		
		this.fillUsernameAndPassword(carryOver, username, password);
		++loginData.currentOrder;
		this.updateLoginData(carryOver, loginData);
	},
	
	
	checkBackgroundProtocol: function(carryOver, loginData) {
		return this.checkProtocol(carryOver.url, loginData.applicationUrl)
	},
	
	
	/****************************/
	/* START abstract functions */
	
	clearLoginData: function(carryOver) {},
	
	fillUsernameAndPassword: function(carryOver, username, password) {},
	
	updateLoginData: function(carryOver, loginData) {},
	
	/**
	 * @param {Document} doc
	 * @param {String} message
	 */
	promptWarningDiag: function(carryOver, message){},
	/* END abstract functions */
	/**************************/

};
global.common.objectExtend(global.login.CentrifyBEHttp401Base, global.common.CentrifyBEBase);
/* END CentrifyBEHttp401Base */
/***************************/



global.net.UserSetting = function() {
	//this.tenantId = 
	//this.username = 
	//this.canCreateAppInAP = null;
	//this.canCreateAppInUP = null;
};

global.net.SERVICE_STATUS_ENUM = {
	  notReady : "no"
	, waitForSetting: "waitForSetting"
	, ready: "ready"
};
global.net.CentrifyServiceBase = function() {
	global.common.CentrifyBEBase.call(this);
	global.common.HasObserverBase.call(this);
};
global.net.CentrifyServiceBase.prototype = {
	
	userSetting: null,
	superpodHostname: null,
	superPodCookieName: null,  // this is on the domain level
	childpodHostname: null,
	status: null,
	
	loggerName: "CentrifyService",
	
	/**
	 * @param {string} path 
	 * @param {object} jsonInput 
	 * @param {function} callback (object)
	 * @param {function} errorCallBack (string, global.net.SERVICE_STATUS_ENUM)
	 * @param {string} method
	 * @return {XMLHttpRequest}
	 */
	request: function(path, jsonInput, callback, errorCallBack, method) {
		var me = this;
		
		if (method === undefined) {
			method = "post";
		}
		var url = "https://" + this.childpodHostname + path;
		
		var xhr  = new XMLHttpRequest();
		xhr.onload = function() {
			me.log("status = " + this.status + " on " + url);
			if (this.status == 200) {
				try {
					var result = JSON.parse(this.responseText);
					try {
						callback(result);
					} catch (e) {
						//me.logError("callback = " + callback);
						me.logError("Error in request callback: " + e);
						if (errorCallBack) {
							errorCallBack("Error in request callback: " + e, this.status);
						}
					}
				} catch (e) {
					me.logError("Bad JSON response: " + e);
					if (errorCallBack) {
						errorCallBack("Bad JSON response: " + e, this.status);
					}
				}
			} else {
				me.logError("Failed: " + "status = " + this.status + " ,text = " + this.responseText);
				if (errorCallBack) {
					errorCallBack("Failed: " + "status = " + this.status 
							+ " ,text = " + this.responseText, 
							this.status);
				}
			}
		};
		xhr.onerror = function(e) {
			me.logError("onerror(): " + e);
			console.log(e);
			if (errorCallBack) {
				errorCallBack("onerror(): " + e, null);
			}
		};
		me.log("connect to " + url + ", method = " + method);
		xhr.open(method, url, true);
		xhr.setRequestHeader("X-CENTRIFY-NATIVE-CLIENT", "TRUE");
		if (jsonInput !== null) {
			xhr.setRequestHeader("Content-Type", "application/json");
		}
		xhr.send(jsonInput !== null ? JSON.stringify(jsonInput) : null);
		return xhr;
	},
	
	init: function(superpodHostname) {
		this.superpodHostname = superpodHostname;
		this.superPodCookieName = null;
		this.childpodHostname = null;

		this.log("superpodHostname = " + this.superpodHostname);
		if (!this.superpodHostname) {
			this.superpodHostname = global.brand.defaultPortalHostname;
		}
		
		// the value should start with dot
		this.superPodCookieName = this.superpodHostname.substring(this.superpodHostname.indexOf(".")); 
		this.checkCurrentStatus();
	},
	
	getChildPodFromPodloc: function(podlocStr) {
		this.logTrace("checking podloc");
		var childpodHostname;
		if (podlocStr) {
			this.logTrace("podlocStr = " + podlocStr);
			try {
				// >= 14.9, the podloc is in base64 format (sort of), see UriSafeBase64Encoder
				var podlocStrTemp = podlocStr
						.replace(/\./g, "+")
						.replace(/\-/g, "/")
						.replace(/_/g, "=")
				;
				podlocStr = atob(podlocStrTemp);
			} catch (e) {
				//TODO make sure all browser works, not only Firefox
				if (this.isInvalidCharacterError(e)) {
					// ignore
					// not in base64 format, maybe this is <= 14.8
					return;
				} else {
					throw e;
				}
			}
			var podloc = JSON.parse(podlocStr);
			childpodHostname = podloc[this.superpodHostname];
			this.logTrace("childpodHostname = " + childpodHostname);
			
			if (!childpodHostname) {
				// fallback to using the superpod hostname
				childpodHostname = this.superpodHostname;
			}
		} else {
			this.logTrace("no podloc");
			// fallback to using the superpod hostname
			childpodHostname = this.superpodHostname;
		}
		return childpodHostname;
	},
	
	isInvalidCharacterError: function(error) {
		return error instanceof DOMException && error.name === "InvalidCharacterError";
	},
	
	updateStatus: function(status) {
		if (this.status == status) {
			//nothing to update;
			return;
		}
		
		switch (status) {
			case global.net.SERVICE_STATUS_ENUM.waitForSetting:
				if (!this.userSetting) {
					this.querySetting();
				}
				break;
			case global.net.SERVICE_STATUS_ENUM.notReady:
				this.userSetting = null;
				break;
		}
		
		this.log("update status from " + this.status + " to " + status);
		this.status = status;
		this.notifyObservers({status: this.status});
	},
	
	querySetting: function(callback) {
		var me = this;
		
		this.request("/security/DoIHaveRight", {rights: ['GrantAppMan']}, function(result) {
			var hasAppManRight = (result.Result.rights.GrantAppMan === true);
			
			me.request(
				"/policy/getpolicybool", 
				{name: '/Core/Security/CDS/Applications/AllowSelfService', def: true}, 
				function(result) {
					var isSelfServiceAllowed = result.Result;
					var userSetting = new global.net.UserSetting();
					userSetting.canCreateAppInAP = hasAppManRight;
					userSetting.canCreateAppInUP = isSelfServiceAllowed;
					var isNewSetting = !me.userSetting;
					me.userSetting = userSetting;
					me.status = global.net.SERVICE_STATUS_ENUM.ready;
					if (isNewSetting) {
						me.notifyObservers({userSetting: me.userSetting, status: me.status});
					} else {
						me.notifyObservers({userSetting: userSetting});
					}
					if (callback) {
						callback(userSetting);
					}
				}
			);
		});
	}
};
global.common.objectExtend(global.net.CentrifyServiceBase, global.common.CentrifyBEBase);
global.common.objectExtend(global.net.CentrifyServiceBase, global.common.HasObserverBase);



global.net.SignalrClientBase = function() {
	global.common.CentrifyBEBase.call(this);
	
	this.stat = {
		status: global.net.SignalrClientBase.prototype.SIGNALR_STATUS_ENUM.Disconnected,
		connectionId: null,
		lastError: null
	};
};
global.net.SignalrClientBase.prototype = {

	loggerName: "signalR",

	SIGNALR_STATUS_ENUM: {
		Disconnected: "disconnected",
		Connecting: "connecting",
		Connected: "connected",
		Error: "error"
	},

	isConnected: function() {
		return !!this.connection;
	},
	
	connect: function() {
		var me = this;
		if (this.isConnected()) {
			throw "already connected";
		}
		
		this.stat.status = me.SIGNALR_STATUS_ENUM.Connecting;
		this.log("connecting to " + this.portalHostname);
		this.connection = global.jQuery.hubConnection(
				"https://" + this.portalHostname + "/signalr", { useDefaultPath: false });
		this.connection.reconnecting(function() {
			me.log("reconnecting");
			me.stat.status = me.SIGNALR_STATUS_ENUM.Connecting;
		});
		this.connection.reconnected(function() {
			me.log("reconnected");
			me.stat.status = me.SIGNALR_STATUS_ENUM.Connected;
			me.stat.connectionId = me.connection.id;
		});
		this.connection.disconnected(function () {
			me.stat.status = me.SIGNALR_STATUS_ENUM.Disconnected;
			var reason = me.connection.lastError ? me.connection.lastError.message : "unknown";
			me.log("disconnected. Reason: " +  reason);
			
		});
		
		var managementHubProxy = this.connection.createHubProxy("managementHub");
		managementHubProxy.on("broadcast", function(target, type, data) {
			me.handleBroadcast(target, type, data);
		});
		
		this.connection.start()
		.done(function() { 
			me.log("Now connected, connection ID=" + me.connection.id); 
			
			managementHubProxy.invoke("subscribeToGroups")
			.done(function () {
				me.stat.status = me.SIGNALR_STATUS_ENUM.Connected;
				me.stat.connectionId = me.connection.id;
				me.log ("Invocation of subscribeToGroups succeeded");
			})
			.fail(function (error) {
				me.stat.status = me.SIGNALR_STATUS_ENUM.Error;
				me.logError("Invocation of subscribeToGroups failed. Error: " + error);
			})
			;
		})
		.fail(function(error) {
			me.stat.status = me.SIGNALR_STATUS_ENUM.Error;
			me.logError("Could not connect. " + error); 
		});
	},
	
	handleBroadcast:  function(target, type, data) {
		this.log("handleBroadcast: target = " + target + ", type = " + type + ", data = " + JSON.stringify(data));
		
		// ManagmentHubs.cs/TargetBroadcast
		switch(target) {
			case "All":
				// type: "Cloud.Service.Alert"
				// data: { Title = string, Message = string, Logout = boolean }
				//TODO
				break;
			case "Tenant":
				//TODO
				break;
			case "Role":
				// type: "Cloud.Saas.UpdateApp"
				// data: {"Application", _RowKey}
				
				// type: "Cloud.Saas.UnPublishApp"
				// data: _RowKey
				
				// type: "Cloud.Saas.PublishApp"
				// data: {"Application", _RowKey, Automatic: boolean}
				
				// type: "Cloud.Saas.RefreshAllApps"
				// data: null
				switch(type) {
					case "Cloud.Saas.UpdateApp":
					case "Cloud.Saas.UnPublishApp":
					case "Cloud.Saas.PublishApp":
					case "Cloud.Saas.RefreshAllApps":
						this.updateAllApps();
						break;
				}
				break;
			case "User":
				// type: "Cloud.Saas.UpdateApp"
				// data: {"Application", _RowKey}
			
				// type: "Cloud.Saas.RefreshAllApps"
				// data: null
			
				// type: "Cloud.Corfe.AuthLevelChange"
				// data: ? AuthenticationAssurance
				
				// type: "Cloud.Saas.ModifyApplicationShortcuts"
				// data: ?
				
				switch(type) {
					case "Cloud.Saas.RefreshAllApps":
					case "Cloud.Saas.UpdateApp":
					case "Cloud.Saas.ModifyApplicationShortcuts":
						this.updateAllApps();
						break;
				}
				break;
			case "UserSession":
				//TODO
				break;
		}
	},
	
	disconnect: function() {
		if (this.isConnected()) {
			// this.log("disconnect connection");
			this.connection.stop();
		}
		this.connection = null;
	},
	
	statusUpdater: function(status) {
		try {
			if (status === global.net.SERVICE_STATUS_ENUM.ready) {
				
				if (!this.isConnected()) {
					this.connect();
				}
			} else {
				this.disconnect();
			}
		} catch(e) {
			this.logError("error in signalr " + e);
		}
	},
	
	getStat: function() {
		return {
			status: this.stat.status,
			connectionId: this.stat.connectionId,
			lastError: this.stat.lastError
		};
	},
	
	updateAllApps: function() {
	
	}

};
global.common.objectExtend(global.net.SignalrClientBase, global.common.CentrifyBEBase);


}).call(_497BFC326A484FAC8AB6B8CD0D886127);
